# %%
import numpy as np
import tensorflow as tf
import os, sys
import matplotlib.pyplot as plt
homeDir = os.path.expanduser("~")
# Edit this path to point to where your working copy of the flux-up code is stored.
sys.path.insert(0,homeDir + "/codes/flux-up")
sys.path.insert(0,homeDir + "/.local/lib/python3.9/site-packages")
import src
import h5py
import src.normalization as norm
sys.path.insert(0,'.')
from src.Pipeline import BasicPipeline as BasicPipeline
import pickle
from scipy.io import savemat
#%%
tf.keras.utils.get_custom_objects().update({'customLoss': None})
tf.keras.utils.get_custom_objects().update({'loss_mae_identity': None})
#%% Read in training data for normalization constants

with open('openmc-runs.pickle', 'rb') as handle:
    pickleData = pickle.load(handle)
trainingRuns = pickleData["trainingRuns"]
trainDatapath = ['../../OpenMC-Runs/{:04d}'.format(num) for num in trainingRuns]
# %% load model
model = tf.keras.models.load_model('checkpoint-model-file')
#%% data to be exported individually
runDirNumbers = [10,15,28,35,34,6,11,27,9,12,19,20,21,22]
for runNum in runDirNumbers:
    outFileName = 'out-{:d}.h5'.format(runNum)
    valDatapath = ['../../OpenMC-Runs/{:04d}'.format(runNum)]
    pl = src.RelativeErrorBasicPipeline()
    train_ds, output_signature, val_ds, normX, normY = pl.connect(trainDatapath,valDatapath)
    pl.export(val_ds, valDatapath,output_signature,model,outFileName)

savemat('norm.mat', {'normX':normX.numpy(),'normY':normY.numpy()})


# %%
#runDirNumbers = [6,9,11,12,19,20,21,22,24,25,26,27]
#outFileName = 'out-combined.h5'
#valDatapath = ['../../OpenMC-Runs/{:04d}'.format(num) for num in runDirNumbers]
#% set up pipeline
#train_ds, output_signature, val_ds, normX, normY = pr.pipeline(trainDatapath,valDatapath)
#% export results
#pr.export(val_ds, valDatapath,output_signature,model,outFileName)

# %%
